/*
  This program tests class called ShowDog.    It instantiates the class
  and calls its methods to see that they are correct.
  
  written by Scott McElfresh
  
  javac ShowDogTester.java ShowDog.java
  java ShowDogTester
*/


public class ShowDogTester 
{	
   public static void main(String [] args)
	{	
	    testOneShowDog("Spot","Dalmation",2, 16);
	    testOneShowDog("Fido","Bulldog",8,4);
	    testOneShowDog("Fifi","Poodle",6 , 2);
	    testOneShowPuppy("Rover","Bloodhound", 8);
	    testOneShowPuppy("Max","Shepherd",4);
	    testOneNewShowPuppy("Ginger","Poodle");
	    testOneNewShowPuppy("Cookie","Beagle");
	    System.out.println("*** Testing of ShowDog class complete.");

	}
	
	// test one instance of the show dog class with the parameters specified
    private static void testOneShowDog(String name, String breed, int age, int pts)
   {
      System.out.println("---------------");
      System.out.println("Testing ShowDog named: " + name);
      System.out.println("Check all toString output to determine that the Champion status is correct.");
      ShowDog d = new ShowDog(name, breed,age,pts);
      System.out.println("    toString:" + d);
      if (! d.getName().equals(name))
          System.out.println("PROBLEM with getName");
      if (! d.getBreed().equals(breed))
          System.out.println("PROBLEM with getBreed");
      if (! (d.getAge() == age))
          System.out.println("PROBLEM with getAge");

      for (int i = 1; i < 10; i++)
      {
         d.oneYearOlder();
         if (! (d.getAge() == (age + i)))
          System.out.println("PROBLEM with oneYearOlder");
      }
      
      if (! (d.getPoints() == pts))
          System.out.println("PROBLEM with getPoints");

      System.out.println("Adding 3 points...");
      for (int i = 1; i <= 5; i++)
      {  
         if ((d.getPoints() >= 15)  && ! d.isChampion())
              System.out.println("PROBLEM: Dog is champion but isChampion method says no.");
         if ((d.getPoints() < 15)  &&  d.isChampion())
              System.out.println("PROBLEM: Dog is NOT champion but isChampion method says it is.");
         System.out.println("Adding 3 points...");
         d.addPoints(3);
         if (! (d.getPoints() == (pts + i * 3)))
            System.out.println("PROBLEM with addPoints");
         System.out.println("    toString:" + d);
      }
   }
   
  	// test one instance of the show dog class with the parameters specified and age 0
  
   private static void testOneShowPuppy(String name, String breed, int points)
   {
      System.out.println("---------------");
      System.out.println("Testing puppy ShowDog named: " + name);
      System.out.println("Check all toString output to determine that the Champion status is correct.");
      ShowDog d = new ShowDog(name, breed, points);
      System.out.println("    toString:" + d);
      if (! d.getName().equals(name))
          System.out.println("PROBLEM with getName");
      if (! d.getBreed().equals(breed))
          System.out.println("PROBLEM with getBreed");
      if (! (d.getAge() == 0))
          System.out.println("PROBLEM with getAge");

      for (int i = 1; i < 10; i++)
      {
         d.oneYearOlder();
         if (! (d.getAge() == ( i)))
          System.out.println("PROBLEM with oneYearOlder");
      }
      
      if (! (d.getPoints() == points))
          System.out.println("PROBLEM with getPoints");

      System.out.println("Adding 3 points...");
      for (int i = 1; i <= 5; i++)
      {  
         if ((d.getPoints() >= 15)  && ! d.isChampion())
              System.out.println("PROBLEM: Dog is champion but isChampion method says no.");
         if ((d.getPoints() < 15)  &&  d.isChampion())
              System.out.println("PROBLEM: Dog is NOT champion but isChampion method says it is.");

         d.addPoints(3);
         if (! (d.getPoints() == (points + i * 3)))
            System.out.println("PROBLEM with addPoints");
         System.out.println("    toString:" + d);
      }
   
   }
   
   // test one instance of the show dog class with the parameters specified and age 0 and
   // points 0
  
   private static void testOneNewShowPuppy(String name, String breed)
   {
      System.out.println("---------------");
      System.out.println("Testing new puppy ShowDog named: " + name);
      System.out.println("Check all toString output to determine that the Champion status is correct.");
      ShowDog d = new ShowDog(name, breed);
      System.out.println("    toString:" + d);
      if (! d.getName().equals(name))
          System.out.println("PROBLEM with getName");
      if (! d.getBreed().equals(breed))
          System.out.println("PROBLEM with getBreed");
      if (! (d.getAge() == 0))
          System.out.println("PROBLEM with getAge");

      for (int i = 1; i < 10; i++)
      {
         d.oneYearOlder();
         if (! (d.getAge() == ( i)))
          System.out.println("PROBLEM with oneYearOlder");
      }
      
      if (! (d.getPoints() == 0))
          System.out.println("PROBLEM with getPoints");

      for (int i = 1; i <= 5; i++)
      {  
         if ((d.getPoints() >= 15)  && ! d.isChampion())
              System.out.println("PROBLEM: Dog is champion but isChampion method says no.");
         if ((d.getPoints() < 15)  &&  d.isChampion())
              System.out.println("PROBLEM: Dog is NOT champion but isChampion method says it is.");

         d.addPoints(3);
         if (! (d.getPoints() == (0 + i * 3)))
            System.out.println("PROBLEM with addPoints");
         System.out.println("    toString:" + d);
      }
   
   }
}